#!/usr/bin/env python
# Copyright 2004,2005 Pierre Martineau <pmartino@users.sourceforge.net>
# This file is part of Bibus, a bibliographic database that can
# work together with OpenOffice.org to generate bibliographic indexes.
#
# Bibus is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Bibus is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bibus; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA.
#
import ConfigParser,os,sys
cp=ConfigParser.ConfigParser()
fileName = sys.argv[0]
while os.path.islink(fileName): fileName = os.readlink(fileName)
sourcedir = os.path.abspath( os.path.dirname(fileName) )
cp.read( os.path.join(sourcedir,'bibus.cfg') )
python = os.path.abspath( cp.get('PATH','python') )
oopath = os.path.abspath( cp.get('PATH','oopath') )
# set environ
if sys.platform.startswith('win'):
	LIBPATH = 'PATH'	# Windows
	QUOTE='"'
else:
	LIBPATH = 'LD_LIBRARY_PATH'	# linux (unix)
	QUOTE=''
try:
	os.environ['PYTHONPATH'] = os.pathsep.join( (os.environ['PYTHONPATH'],oopath) )
except KeyError:
	os.environ['PYTHONPATH'] = oopath
try:
	os.environ[LIBPATH] = os.pathsep.join( (os.environ[LIBPATH],oopath) )
except KeyError:
	os.environ[LIBPATH] = oopath
# starting Bibus
os.execl( python , os.path.basename(python) , QUOTE+ os.path.join(sourcedir,'bibus.py') +QUOTE )
